/* hex2crt.C   By Tom Harrold      8/24/90
 */

#include <stdio.h>
#include <conio.h>
#include <share.h>
#include <dos.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

main(argc, argv)    /* get command line arguments from the DOS prompt */
    int argc;       /* number of command line arguments */
    char *argv[];   /* actual command line arguments */
{
    FILE *infile, *outfile;
	char inpath[_MAX_PATH], outpath[_MAX_PATH];
	char drive[_MAX_DRIVE], dir[_MAX_DIR];
	char fname[_MAX_FNAME], ext[_MAX_EXT];
    char cwd[_MAX_DIR];
	int  in, size, j, k, len, result, psign;
	long i = 0L;
	psign =1;

/* Get the current working directory. */
    getcwd( cwd, _MAX_DIR );
/*    printf( "Current working directory: %s\n", cwd ); */
    len = strlen( cwd );
/*    printf("Length of pathname: %d\n", len); */
    for( j=2;j<len;j++)        /* copy the directory name, ignore drive */
    dir[k++] = cwd[j];
    dir[k] = 0;                 /* install string terminator as zero */

/* Get current drive. */
    drive[0] = cwd[0];      /* copy drive name */
    drive[1] = ':';         /* must have a colen after drive name */
    drive[2] = 0;           /* install string terminator as zero */

    if (argc == 1)
    {

/* Query for and open input file. */

    printf( "Enter input file name: " );
	gets( inpath );
    }

/* check if user entered something for the filename */

    if (argc > 1)
    {
    /* check if user needs help on how to use this program because, filename
    not given   */

	result = strcmpi( "?", argv[1] );
	if (result == 0)
	{
        printf("To use: hex2crt filename \n\n");
        printf("\tThis will do a hexadecimal dump on the CRT of the contents\n");
        printf("\tin the input file name. It also will dump into an output\n");
        printf("\tfile with the same name except, the extention name will\n");
        printf("\tbe: .hx  \n\n");
		exit(0);
	}
	strcpy( inpath, argv[1]);  /* get filename from command line */
    }

	if(argc >2)
		if(argv[2][0] == '/')
			if(argv[2][1] == 's')
				psign = 0;

	if(psign)
	{
/* print signon message */

		printf("\nHEX2CRT. Ver. 1.0\n");
		printf("Written by Tom Harrold AUG, 1990\n");
		printf("Downloaded from the HIGH GATE DESIGNS BBS\n");
		printf("(408) 255-9742\n\n");
	}


	strcpy( outpath, inpath );

/* Make attemp to open users input file */

    if( (infile = fopen( inpath, "rb" )) == NULL )
	{
		printf( "Can't open input file: %d", errno );
		exit( 1 );
	}

/* Build output file by splitting path and rebuilding with
	 * new extension.
	 */
	_splitpath( outpath, drive, dir, fname, ext );
	strcpy( ext, "hx" );
	_makepath( outpath, drive, dir, fname, ext );

/* Open output file for writing. Using _fsopen allows use to ensure
	 * that no one else writes to the file while we are writing to it.
	 */
	if( (outfile = _fsopen( outpath, "wb", SH_DENYWR )) == NULL )
	{
		printf( "Can't open output file: %d", errno );
		exit( 1 );
	}

	printf( "Creating %s from %s . . .\n", outpath, inpath );
/*    printf( "(B)yte or (W)ord: " );
	size = getche(); */
	printf("Hex dump of file %s:\n\n", outpath );
    size = 'b';

/* Get each character from input and write to output and the CRT. */
	while( 1 )
	{
		if( (size == 'W') || (size == 'w') )
		{
			in = getw( infile );
			if( (in == EOF) && (feof( infile ) || ferror( infile )) )
				break;
			fprintf( outfile, " %.4X", in );
			if( !(++i % 8) )
				putw( 0x0A0D, outfile );        /* New line      */
		}
		else
		{
			/* This example uses the fgetc and fputc functions. You
			 * could also use the macro versions:
			in = getc( infile );
			 */
			in = fgetc( infile );
			if( (in == EOF) && (feof( infile ) || ferror( infile )) )
				break;
            printf(  " %.2X", in );
            fprintf( outfile, " %.2X", in );
            if( !(++i % 16) )
			{
				/* Macro version:
				putc( 13, outfile );
				putc( 10, outfile );
				 */
                fputc( 13, outfile );           /* New line      */
                fputc( 10, outfile );
                printf("\n");
			}
		}
	}
	printf("\n\n");
	fcloseall();
	exit( 0 );
}


